; SIMPLY NOISE (2015) for realtime Csound6
; Demo of HTML5 "drumset" performance GUI for all size Android smartphones and tablets
; Note the inherent latency issue.
;   GUI is at bottom of file, and contains 12 full "touch down/touch up" buttons (no sliders)
    Button code significantly augmented to respond to button "touch up"
; Requires Android OS 4.2.2+, and Csound6[.05].apk or higher
;   Downloadable from http://sourceforge.net/projects/csound/files/csound6/Csound6.05/
;   Run Csound6, and Browse to (Open) this file
;   In case of audio glitches, reduce the value of sr (Sample Rate, see below)
;    progressively to 32000, 22050, 11025 or 8000 until glitching disappears.

<CsoundSynthesizer>
<CsOptions>

-odac -m0d

</CsOptions>
<CsInstruments>

sr      = 44100 ; Sample Rate
ksmps   = 100
nchnls  = 2

        instr 1

kamp    init 11000
kamp1   chnget "amp1"
kamp1a  trigger  kamp1, .5, 0
        if kamp1a == 1 then
kamp   = 1000
        endif
kamp2   chnget "amp2"
kamp2a  trigger  kamp2, .5, 0
        if kamp2a == 1 then
kamp   = 4500
        endif
kamp3   chnget "amp3"
kamp3a  trigger  kamp3, .5, 0
        if kamp3a == 1 then
kamp   = 11000
        endif
kamp4   chnget "amp4"
kamp4a  trigger  kamp4, .5, 0
        if kamp4a == 1 then
kamp   = 23000
        endif

ktrig1	chnget "noise1"
ktrig1a trigger  ktrig1, .5, 0
        if ktrig1a == 1 then
event "i", 2, 0, -1, kamp, 8.00
        endif
ktrig1b trigger  ktrig1, .5, 1
        if ktrig1b == 1 then
        event "i", -2, 0, 0   
        endif
ktrig2  chnget "noise2"
ktrig2a trigger ktrig2, .5, 0
           if ktrig2a == 1 then
           event "i", 3, 0, -1, kamp, 8.02
           endif
ktrig2b trigger ktrig2, .5, 1
           if ktrig2b == 1 then
           event "i", -3, 0, 0
           endif
ktrig3  chnget "noise3"
ktrig3a trigger ktrig3, .5, 0
           if ktrig3a == 1 then
           event "i", 4, 0, -1, kamp, 8.04
           endif
ktrig3b trigger ktrig3, .5, 1
           if ktrig3b == 1 then
           event "i", -4, 0, 0
           endif
ktrig4  chnget "noise4"
ktrig4a trigger ktrig4, .5, 0
           if ktrig4a == 1 then
           event "i", 5, 0, -1, kamp, 8.05
           endif
ktrig4b trigger ktrig4, .5, 1
           if ktrig4b == 1 then
           event "i", -5, 0, 0
           endif
ktrig5  chnget "noise5"
ktrig5a trigger ktrig5, .5, 0
           if ktrig5a == 1 then
           event "i", 6, 0, -1, kamp, 8.07
           endif
ktrig5b trigger ktrig5, .5, 1
           if ktrig5b == 1 then
           event "i", -6, 0, 0
           endif
ktrig6  chnget "noise6"
ktrig6a trigger ktrig6, .5, 0
           if ktrig6a == 1 then
           event "i", 7, 0, -1, kamp, 8.09
           endif
ktrig6b trigger ktrig6, .5, 1
           if ktrig6b == 1 then
           event "i", -7, 0, 0
           endif
ktrig7  chnget "noise7"
ktrig7a trigger ktrig7, .5, 0
           if ktrig7a == 1 then
           event "i", 8, 0, -1, kamp, 8.11
           endif
ktrig7b trigger ktrig7, .5, 1
           if ktrig7b == 1 then
           event "i", -8, 0, 0
           endif
ktrig8  chnget "noise8"
ktrig8a trigger ktrig8, .5, 0
           if ktrig8a == 1 then
           event "i", 9, 0, -1, kamp, 8.12
           endif
ktrig8b trigger ktrig8, .5, 1
           if ktrig8b == 1 then
           event "i", -9, 0, 0
           endif

        endin
        
        instr 2, 3, 4, 5, 6, 7, 8, 9
        
kamp    expsegr 10, .05, p4, 5, 10, .5, 10
anoise  noise kamp, 0
ifreq   = cpspch(p5)
a1      reson anoise, ifreq, ifreq * .1, 2
        outs a1, a1
        
        endin

</CsInstruments>
<CsScore>

i 1 0 3600

e

</CsScore>
</CsoundSynthesizer>

<html>
<head>
<style type="text/css">

.noselect {
        -webkit-user-select: none;
}

table td {
	text-align: center;
	color: white;
	background-color: teal; /* user choice */
}

/* buttons are full "touch down/touch up"; they send Csound a 1 upon touch down, and a 0 at touch up */
.buttons {
        width: 80%; /* 100% or less, horizontally centered */
}        
.buttons td {
	background-color: cadetblue; /* user choice */
}

</style>

</head>
<body>

<div class="noselect">

<big><big><b>SIMPLY NOISE</b></big> Enhanced Button</big><br>
 &nbsp; Demo HTML5 "drumset" GUI
<br><br>

<table class="buttons" style="margin: auto;">
<!-- # of maximum characters per label depends on # of buttons per row and % width of row (here 4 buttons with 80% row width) --!>
<!-- # of characters of longest string should be the same for each button per row --!>
<!-- button is only clickable in text area --!>
<!-- text area can be elongated by adding spaces and non-blanking spaces [&nbsp:] --!>
<tr>
<td>
<button class="butt_height"  id="noise1">Noise<br>1</button>
</td>
<td>
<button class="butt_height" id="noise2">Noise<br>2</button>
</td>
<td>
<button class="butt_height" id="noise3">Noise<br>3</button>
</td>
<td>
<button class="butt_height" id="noise4">Noise<br>4</button>
</td>
</tr>
<tr>
<td>
<button class="butt_height" id="noise5">Noise<br>5</button>
</td>
<td>
<button class="butt_height" id="noise6">Noise<br>6</button>
</td>
<td>
<button class="butt_height" id="noise7">Noise<br>7</button>
</td>
<td>
<button class="butt_height" id="noise8">Noise<br>8</button>
</td>
</tr>
</table><br>

<div align="center">
8 "Drums" (Noises)<br><br>

<table class="buttons" style="margin: auto;">
<tr>
<td>
<button class="butt_height" id="amp1"> Amp <br>1</button>
</td>
<td>
<button class="butt_height" id="amp2"> Amp <br>2</button>
</td>
<td>
<button class="butt_height" id="amp3"> Amp <br>3</button>
</td>
<td>
<button class="butt_height" id="amp4"> Amp <br>4</button>
</td>
</tr>
</table><br>

4 Amplitude Levels
</div>

<script>

/* adjust button height (% of screen) here */
var button_height_fraction = 0.1;

var screen_height = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
var screen_width = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
var elements2 = document.getElementsByClassName("butt_height");
Array.prototype.forEach.call(elements2, function(element) {
	element.setAttribute("style", "height: "+ screen_height * button_height_fraction +"px;");
});

noise1.addEventListener("touchstart", startTouch1);
noise1.addEventListener("touchend", stopTouch1);
function startTouch1(event) {
	event.preventDefault();
	csound.setControlChannel('noise1', 1);
}
function stopTouch1(event) {
	event.preventDefault();
	csound.setControlChannel('noise1', 0);
}

noise2.addEventListener("touchstart", startTouch2);
noise2.addEventListener("touchend", stopTouch2);
function startTouch2(event) {
	event.preventDefault();
	csound.setControlChannel('noise2', 1);
}
function stopTouch2(event) {
	event.preventDefault();
	csound.setControlChannel('noise2', 0);
}

noise3.addEventListener("touchstart", startTouch3);
noise3.addEventListener("touchend", stopTouch3);
function startTouch3(event) {
	event.preventDefault();
	csound.setControlChannel('noise3', 1);
}
function stopTouch3(event) {
	event.preventDefault();
	csound.setControlChannel('noise3', 0);
}

noise4.addEventListener("touchstart", startTouch4);
noise4.addEventListener("touchend", stopTouch4);
function startTouch4(event) {
	event.preventDefault();
	csound.setControlChannel('noise4', 1);
}
function stopTouch4(event) {
	event.preventDefault();
	csound.setControlChannel('noise4', 0);
}

noise5.addEventListener("touchstart", startTouch5);
noise5.addEventListener("touchend", stopTouch5);
function startTouch5(event) {
	event.preventDefault();
	csound.setControlChannel('noise5', 1);
}
function stopTouch5(event) {
	event.preventDefault();
	csound.setControlChannel('noise5', 0);
}

noise6.addEventListener("touchstart", startTouch6);
noise6.addEventListener("touchend", stopTouch6);
function startTouch6(event) {
	event.preventDefault();
	csound.setControlChannel('noise6', 1);
}
function stopTouch6(event) {
	event.preventDefault();
	csound.setControlChannel('noise6', 0);
}

noise7.addEventListener("touchstart", startTouch7);
noise7.addEventListener("touchend", stopTouch7);
function startTouch7(event) {
	event.preventDefault();
	csound.setControlChannel('noise7', 1);
}
function stopTouch7(event) {
	event.preventDefault();
	csound.setControlChannel('noise7', 0);
}

noise8.addEventListener("touchstart", startTouch8);
noise8.addEventListener("touchend", stopTouch8);
function startTouch8(event) {
	event.preventDefault();
	csound.setControlChannel('noise8', 1);
}
function stopTouch8(event) {
	event.preventDefault();
	csound.setControlChannel('noise8', 0);
}

amp1.addEventListener("touchstart", startTouch9);
amp1.addEventListener("touchend", stopTouch9);
function startTouch9(event) {
	event.preventDefault();
	csound.setControlChannel('amp1', 1);
}
function stopTouch9(event) {
	event.preventDefault();
	csound.setControlChannel('amp1', 0);
}

amp2.addEventListener("touchstart", startTouch10);
amp2.addEventListener("touchend", stopTouch10);
function startTouch10(event) {
	event.preventDefault();
	csound.setControlChannel('amp2', 1);
}
function stopTouch10(event) {
	event.preventDefault();
	csound.setControlChannel('amp2', 0);
}

amp3.addEventListener("touchstart", startTouch11);
amp3.addEventListener("touchend", stopTouch11);
function startTouch11(event) {
	event.preventDefault();
	csound.setControlChannel('amp3', 1);
}
function stopTouch11(event) {
	event.preventDefault();
	csound.setControlChannel('amp3', 0);
}

amp4.addEventListener("touchstart", startTouch12);
amp4.addEventListener("touchend", stopTouch12);
function startTouch12(event) {
	event.preventDefault();
	csound.setControlChannel('amp4', 1);
}
function stopTouch12(event) {
	event.preventDefault();
	csound.setControlChannel('amp4', 0);
}

</script>

<div>
</body>
</html>